This is the repository of the Tarot source code.  Welcome!

Watch the introduction video on [Peertube](https://scitech.video/videos/watch/c9768d7f-7ac3-4b64-8c79-91d5732d7454?subtitle=en).

<iframe width="560" height="315" sandbox="allow-same-origin allow-scripts" src="https://scitech.video/videos/embed/c9768d7f-7ac3-4b64-8c79-91d5732d7454?subtitle=en" frameborder="0" allowfullscreen></iframe>

Keep up to date with the video NEWS:

<iframe width="560" height="315" sandbox="allow-same-origin allow-scripts" src="https://scitech.video/videos/embed/87aa39e8-6a54-4cda-92dd-f91a06760bc6" frameborder="0" allowfullscreen></iframe>


# Download the software

You have several options.


## Not using Windows: try your habitual software distribution

How do you usually download software?  Try that method with the name
`tarot`, or `eu.planete_kraus.Tarot`.  If there is no such package,
please tell me so that I can work on porting the app to this platform.
There is only a requirement: the platform should be able to distribute
GPLv3+-licensed applications.


## Still not using Windows, but the above failed: use a supported package manager

Package managers are recommended since they let you stay up to date
with each release.  Tarot tries to be available with as many package
managers as possible, however there are a few restrictions.


### You're running a debian- or ubuntu-based system: use apt

You can install tarot system-wide.  Run these commands as **root**.

    ## Install the packages for custom repositorise
    apt install -y wget gnupg apt-transport-https
    
    ## Add the tarot signing key
    wget https://play-tarot.frama.io/tarot-deb/tarot.gpg -O- | apt-key add -
    
    ## Add the archive
    wget https://play-tarot.frama.io/tarot-deb/tarot.list -O /etc/apt/sources.list.d/tarot.list
    
    ## Update your list of packages
    apt update
    
    ## Install the package
    apt install tarot


### Your favorite package manager is not listed here

Please tell me.  There are a few restrictions on which package
managers are listed here:

-   the package managers should be free software (*free* as in
    <https://www.fsf.org/>);
-   the package manager should not build the package with a non-free
    toolchain;
-   the package manager should either be decentralized (it should be
    possible to use it without its "main" archive) or its archive should
    have a clear policy on accepting only free software.


## Windows users: download the installer

The latest release is provided as a NSIS installer at
<https://play-tarot.frama.io/tarot-mingw/tarot-setup.exe>.


## Otherwise: download a release and compile it

Visit <https://play-tarot.frama.io/tarot-releases/> and download one of
the releases.  No checksum is provided because they are available
under HTTPS.

The usual steps to compile the project are:

    ./configure && make && sudo make install


## Just for fun: compile from source

Clone the <https://framagit.org/play-tarot/tarot> repository, run the
`autogen.sh` script and follow the usual steps to compile the project.
Please note that you need to have lots of maintainer-dependencies,
like the Autotools, Vala or Emacs in order to do that.


## Cutting-edge development

Each commit on the repository has an attached distribution and
Mingw-compiled setup, as a Gitlab artifact.


# Documentation

There is an online version of the manual at
<https://play-tarot.frama.io/tarot/share/doc/tarot/tarot.html/index.html#Top>.

If you have a bug, you don't understand something, or have a dream,
come and share it with me on the fediverse (`@vk@mamot.fr`) or by
email.

